//
//  database1AppDelegate.m
//  database1
//
//  Created by Yariv Katz on 10/25/10.
//  Copyright YKSoftware 2010. All rights reserved.
//

#import "database1AppDelegate.h"
#import "RootViewController.h"
#import "singleStudent.h"

@implementation database1AppDelegate

@synthesize window;
@synthesize navigationController;
@synthesize aryDatabase;

#pragma mark -
#pragma mark Application lifecycle

-(void)updateNames{
	databaseName = @"students7.sqlite";
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
}



-(void) checkAndCreateDatabase{
	BOOL success;
	NSFileManager *fileManager = [NSFileManager defaultManager];
	success = [fileManager fileExistsAtPath:databasePath];
	//if(success) return;
	NSString *databasePathFromApp = [[[NSBundle mainBundle] resourcePath] stringByAppendingPathComponent:databaseName];
	[fileManager copyItemAtPath:databasePathFromApp toPath:databasePath error:nil];
	[fileManager release];
}


-(void) readWordsFromDatabase {
	[self updateNames];
	db = [FMDatabase databaseWithPath:databasePath];
	aryDatabase = [[NSMutableArray alloc] init];
	[db setLogsErrors:TRUE];
	[db setTraceExecution:TRUE];
	if (![db open]) { 
		NSLog(@"Could not open db."); 
		return; 
	}else { 
		NSLog(@"oooooooohooo. DB Open...."); 
	}
	FMResultSet *rs = [db executeQuery:@"select * from student"]; 
	while ([rs next]) {
		int aID = [rs intForColumn:@"id"];
		int intPk=[rs intForColumn:@"pk"];
		NSString* aName = [rs stringForColumn:@"name"];
		NSLog(@"%s",aName);
		singleStudent* sStudent = [[singleStudent alloc] initWithData:intPk :aName :aID]; 
		[aryDatabase addObject:sStudent];
		[sStudent release];
	}
	[db close];
}


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    
    
    // Override point for customization after application launch.
    
    // Add the navigation controller's view to the window and display.
	[self updateNames];
	[self checkAndCreateDatabase];
	[self readWordsFromDatabase];
    [window addSubview:navigationController.view];
    [window makeKeyAndVisible];

    return YES;
}


- (void)applicationWillResignActive:(UIApplication *)application {
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}


- (void)applicationDidEnterBackground:(UIApplication *)application {
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, called instead of applicationWillTerminate: when the user quits.
     */
}


- (void)applicationWillEnterForeground:(UIApplication *)application {
    /*
     Called as part of  transition from the background to the inactive state: here you can undo many of the changes made on entering the background.
     */
}


- (void)applicationDidBecomeActive:(UIApplication *)application {
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}


- (void)applicationWillTerminate:(UIApplication *)application {
    /*
     Called when the application is about to terminate.
     See also applicationDidEnterBackground:.
     */
}


#pragma mark -
#pragma mark Memory management

- (void)applicationDidReceiveMemoryWarning:(UIApplication *)application {
    /*
     Free up as much memory as possible by purging cached data objects that can be recreated (or reloaded from disk) later.
     */
}


- (void)dealloc {
	[navigationController release];
	//[aryDatabase release];
	//[db release];
	
	[window release];
	[super dealloc];
}


@end

